#!/usr/bin/python2
# -*- encoding:utf-8 -*-

import gtk
import pygtk
from sys import argv
from os import environ
import pynotify
import slidewall
import conf


class Gui():
    
    p = None        # istanza di Slidewall
    tmp = None
    #UIfile = "/home/tommaso/Repo/Slidewall/main.ui"
    UIfile = "/home/tommaso/Repo/Slidewall/bis_main.ui"
    
    def __init__(self, slidewall_instance=None):
        self.signals = {
	    'on_file_clicked': self.on_file_clicked,
	    'on_directory_clicked': self.on_directory_clicked,
	    'on_rm_clicked': self.on_rm_clicked,
            'on_old_xml_clicked' : self.on_old_xml_clicked,
	    'on_main_destroy': self.on_window_destroy,
            'on_name_changed' : self.on_name_changed,
            'on_reset_clicked' : self.on_reset_clicked,
            'on_make_clicked' : self.on_make_clicked,
            'on_cancel_clicked' : self.on_cancel_clicked,
            'on_open_clicked' : self.on_open_clicked,
            'on_cancelD_clicked' : self.on_cancelD_clicked,
            'on_openD_clicked' : self.on_openD_clicked,
            'on_cancelX_clicked' : self.on_cancelX_clicked,
            'on_openX_clicked' : self.on_openX_clicked,
            'on_hold_duration_value_changed' : self.on_hold_duration_value_changed,
            'on_transition_duration_value_changed' : self.on_hold_duration_value_changed,
            'on_tagtext_changed' : self.on_tagtext_changed,
            'on_tagadd_clicked' : self.on_tagadd_clicked
	    }
	
	self.builder = gtk.Builder()
	self.builder.add_from_file (self.UIfile)
	self.window = self.builder.get_object("main")
	self.file_button = self.builder.get_object("file")
        self.file_list = self.builder.get_object("file_list")
        self.get_file = self.builder.get_object("get_file")
        self.get_dir = self.builder.get_object("get_dir")
        self.get_xml = self.builder.get_object("get_xml")
        self.statusbar = self.builder.get_object("statusbar")
        
        self.tags = ''
        
        if slidewall_instance:
            self.p = slidewall_instance
            self.file_list_update()
        else:
            self.p = slidewall.Slidewall("New_Slideshow")
        self.nfield = self.builder.get_object("nfield")
        self.nfield.set_text(self.p.name)
        pynotify.init("Slidewall")
	
#self.file_button.connect ("clicked", self.on_file_clicked)
#self.window.connect ("destroy", self.on_window_destroy)
	
        self.builder.connect_signals (self.signals)
	
    def start(self):
        self.window.show_all()
        gtk.main()
		    
    def on_window_destroy (self, window = None):
        gtk.main_quit ()
		
    def on_directory_clicked (self, button = None):
        self.get_dirs()
        self.file_list_update()

    def on_file_clicked (self, file_button = None):
#        file_button.child.set_text ("Pirla")
        self.get_files()
        self.file_list_update()

    def on_rm_clicked (self, button = None):        #Non funzionerà mai con gtktextview, va messo gtktreeview
        pass

    def on_old_xml_clicked (self, button = None):
        self.get_old_xml()
        self.file_list_update()
    
    def on_name_changed(self, TextObj):
        text = TextObj.get_text()
        self.p.set_name(text)
        self.p.set_dest("%s/%s" %(conf.defaults["dest_dir"], text))
        self.p.set_xml("%s/%s.xml" %(self.p.dest_dir, text))
#        print "ehi! Il nome è: %s" %(text)
        
    def on_make_clicked(self, ButtonObj):
        self.notify("Make!!!")
        self.p.make_xml()
        self.p.mkdir()
        self.p.cp_files()
        self.p.write_xml()
        self.notify("Done!!!")
        
    def on_reset_clicked(self, ButtonObj = None):
        self.p.set_name("NewSlideshow")
        self.nfield = self.builder.get_object("nfield")
        self.nfield.set_text(self.p.name)
        self.p.files = []
        self.file_list_update(1)
        self.notify("Reset!!!")
        
    def get_files(self):
        if not self.get_file: self.get_file = self.builder.get_object("get_file")
        self.get_file.run()
        if self.tmp:
            self.p.files.extend(self.tmp)
            self.file_list_update()
            self.notify("New files added...")
    
    def get_dirs(self):
        if not self.get_dir: self.get_dir = self.builder.get_object("get_dir")
        self.get_dir.run()
        if self.tmp:
            self.p.directories.extend(self.tmp)
            self.p.dirs2files()
            self.file_list_update()
            self.notify("New directory added...")

    def get_old_xml(self):
        if not self.get_xml: self.get_xml = self.builder.get_object("get_xml")
        self.get_xml.run()
        if self.tmp:
            self.p.r_xml_file = self.tmp[0]
            self.p.read_xml()
            self.file_list_update()
            self.notify("Xml file loaded: %s" %(self.tmp))
            
    def on_cancel_clicked(self, Button):
        self.get_file.destroy()

    def on_open_clicked(self, Button):
        lista = self.get_file.get_filenames()
        self.get_file.destroy()
        self.tmp = lista

    def on_cancelD_clicked(self, Button):
        self.get_dir.destroy()

    def on_openD_clicked(self, Button):
        lista = self.get_dir.get_filenames()
        self.get_dir.destroy()
        self.tmp = lista
    
    def on_cancelX_clicked(self, Button):
        self.get_xml.destroy()
    
    def on_openX_clicked(self, Button):
        lista = self.get_xml.get_filenames()
        self.get_xml.destroy()
        self.tmp = lista
    
    def file_list_update(self, reset = 0):
        if not self.file_list: self.file_list = self.builder.get_object("file_list")
        BufObj = self.file_list.get_buffer()
        start = BufObj.get_start_iter()
        end = BufObj.get_end_iter()
        Buf = BufObj.get_text(start, end)
        if not reset:
            if '\n' in Buf: BufList = [s for s in Buf.split('\n') if s]
            else: BufList = [Buf]
            Extension = [s for s in self.p.files if s not in BufList]
            BufList.extend(Extension)
            Buf = BufList[0]
            for s in BufList[1:]:
                Buf = Buf + '\n' + s
        else: Buf = ''
        BufObj.set_text(Buf)
        self.file_list.set_buffer(BufObj)
        
    def file_tree_update(self, reset = 0):        # da chiamare file_tree_update
        if not self.file_tree: self.file_tree = self.builder.get_object("file_tree")
        Columns = self.file_tree.get_columns()

    def notify(self, message, icon = None):
        if not self.statusbar: self.statusbar = self.builder.get_object("statusbar")
        context = self.statusbar.get_context_id(message)
        self.statusbar.push(context, message)
        n = pynotify.Notification("SlideWall", "%s says:\n\t%s" %(self.p.name, message), icon)
        n.set_urgency(pynotify.URGENCY_CRITICAL)
        n.set_timeout(1000)
        n.show()

    def on_hold_duration_value_changed(self):
        self.notify("Puzzi!")
    
    def on_transition_duration_value_changed(self):
        self.notify("Puzzi!")
    
    def on_tagtext_changed(self, TextObj = None):        # da mettere in un thread a parte? o forse cambiare segnale
        self.TagTextObj = TextObj        
    
    def on_tagadd_clicked(self, ButtonObj = None):
        self.notify("It may take a while...")
        text = self.TagTextObj.get_text()
        self.tags = text
        self.p.tag_list = text.split(',')
        self.p.tag_preload()
        self.p.add_tagged()
        self.file_list_update()
        

    
if __name__ == "__main__":
    app = Gui ()
    app.start ()
