#!/usr/bin/python2

import os
import pyexiv2

class TagFilter():

    libpath = ''
    imglib = []
    filtered = []               # lista di tuple (img, lista_tags) prima, poi lista
    tag_list = []
    total = 0
    found = 0
    untagged = 0
    errors = 0
    error_l = []
    
    def __init__(self, lib = ''):
        self.libpath = lib

    def populate_lib(self):
        self.total = 0
        for root, subFolders, files in os.walk(self.libpath):
            for f in files:
                self.imglib.append(os.path.join(root,f))
                self.total += 1

    def filter(self):
        self.found = 0
        self.untagged = 0
        self.errors = 0
        for img in self.imglib:
            try:
                metadata = pyexiv2.ImageMetadata(img)
                metadata.read()
                try:
                    related_tags = [ x for x in self.tag_list if x in metadata['Iptc.Application2.Keywords'].raw_value ]
                    if related_tags :
                        self.filtered.append( (img, related_tags) )
                        self.found += 1
                except: self.untagged += 1
            except:
                self.errors += 1
                self.error_l.append(img)
                
    def cup(self):
        """Fa l'unione di tutte le foto con almeno un tag scelto"""
        self.filtered = [ x[0] for x in self.filtered ] # prende solo il nomefile
    
    def cap(self):
        """Fa l'intersezione di quelle con tutti i tags"""
        self.filtered = [ x[0] for x in self.filtered if x[1]==self.tag_list ]
#EOF
#p = TagFilter()
#p.libpath = '/home/tommaso/Immagini/Photos'
#p.tag = ['margherita']
#
#p.populate_lib()
#p.filter()
#print "Found %d photos tagged as %s in a library of %d\nEncountered %d untagged photos and %d errors\nThese files gave error:\n%s" %(p.found, p.tag, p.total, p.untagged, p.errors, str(p.error_l))
